# ---------------------------------------------------------------------------
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ---------------------------------------------------------------------------
apiVersion: camel.apache.org/v1alpha1
kind: Kamelet
metadata:
  name: jms-ibm-mq-sink
  annotations:
    camel.apache.org/kamelet.icon: "data:image/svg+xml;base64,[encoded data, 5208 characters]"
    camel.apache.org/kamelet.support.level: "Stable"
    camel.apache.org/provider: "Apache Software Foundation"
    camel.apache.org/catalog.version: "3.21.0"
    camel.apache.org/kamelet.group: "JMS"
    camel.apache.org/kamelet.namespace: "Messaging"
  labels:
    camel.apache.org/kamelet.type: "sink"
    camel.apache.org/requires.runtime: camel-k
spec:
  definition:
    title: "JMS - IBM MQ Sink"
    description: |-
      A Kamelet that can produce events to an IBM MQ message queue using JMS.

      In your KameletBinding file, you must explicitly declare the IBM MQ Server driver dependency in spec->integration->dependencies

      - "mvn:com.ibm.mq:com.ibm.mq.allclient:<version>"

    required:
      - serverName
      - serverPort
      - destinationName
      - queueManager
      - channel
      - username
      - password
    type: object
    properties:
      serverName:
        title: "IBM MQ Server name"
        description: "IBM MQ Server name or address"
        type: string
      serverPort:
        title: "IBM MQ Server Port"
        description: "IBM MQ Server port"
        type: integer
        default: 1414
      destinationType:
        title: "Destination Type"
        description: "The JMS destination type (queue or topic)"
        type: string
        default: queue
      destinationName:
        title: "Destination Name"
        description: "The destination name"
        type: string
      queueManager:
        title: "IBM MQ Queue Manager"
        description: "Name of the IBM MQ Queue Manager"
        type: string
      channel:
        title: "IBM MQ Channel"
        description: "Name of the IBM MQ Channel"
        type: string
      clientId:
        title: "IBM MQ Client ID"
        description: "Name of the IBM MQ Client ID"
        type: string
      username:
        title: "Username"
        description: "Username to authenticate to IBM MQ server"
        type: string
      password:
        title: "Password"
        description: "Password to authenticate to IBM MQ server"
        type: string
        format: password
        x-descriptors:
        - urn:alm:descriptor:com.tectonic.ui:password
        - urn:camel:group:credentials
  dependencies:
  - "camel:jms"
  - "camel:kamelet"
  template:
    beans:
      - name: wmqConnectionFactory
        type: "#class:com.ibm.mq.jms.MQConnectionFactory"
        property:
          - key: XMSC_WMQ_HOST_NAME
            value: '{{serverName}}'
          - key: XMSC_WMQ_PORT
            value: '{{serverPort}}'
          - key: XMSC_WMQ_CHANNEL
            value: '{{channel}}'
          - key: XMSC_WMQ_QUEUE_MANAGER
            value: '{{queueManager}}'
          - key: XMSC_WMQ_CONNECTION_MODE
            value: 1
          - key: XMSC_USERID
            value: '{{username}}'
          - key: XMSC_PASSWORD
            value: '{{password}}'
          - key: XMSC_CLIENT_ID
            value: '{{?clientId}}'
    from:
      uri: "kamelet:source"
      steps:
      - to:
          uri: "jms:{{destinationType}}:{{destinationName}}"
          parameters:
            connectionFactory: "#bean:{{wmqConnectionFactory}}"